
var gtx_dep_lastclick = 0;
var gtx_dep_threshold = 1200;


// Double execution protection of java script calls
function gtx_dep(args)
{
     var now = new Date().getTime();
     if(! (now-gtx_dep_lastclick)<gtx_dep_threshold) {
        eval (args);
     }
     
     gtx_dep_lastclick = now;
}


function overrideKey( evalStr, key, shift, ctrl, alt, event )
{
	var ekey, shift, ctrl, alt;
	if ( window.event )
		event = window.event;
	ekey = event.keyCode;
	eshift = event.shiftKey;
	ectrl = event.ctrlKey;
	ealt = event.altKey;
	<? if ( $DEBUG["echo"] && $DEBUG["keys"] ) echo "alert(ekey);\n"; ?>
	if ( ekey == key && shift == eshift && ctrl == ectrl && alt == ealt )
		eval( evalStr );
	else
		return true;
	return false;
}

function overrideReturn( evalStr, event )
{
	return overrideKey( evalStr, 13, false, false, false, event );
}

function overrideModReturn( evalStr, shift, ctrl, alt, event )
{
	return overrideKey( evalStr, 13, shift, ctrl, alt, event );
}


// keys: array of array( 0=evalStr, 1=key, 2=shift, 3=ctrl, 4=alt )
function overrideKeys( keys, event )
{
	var i;
	if ( !keys ) return true;
	for ( i = 0; i < keys.length; i++ )
	{
		if ( !overrideKey( keys[i][0], keys[i][1], keys[i][2], keys[i][3], keys[i][4], event ) )
			return false;
	}
	return true;
}

function showAssHelp( title, text )
{
	if ( top.main )
		if (top.main.ass )
			top.main.ass.ass_help( title, text );
}

function clearAssHelp()
{
	if ( top.main )
		if (top.main.ass )
			top.main.ass.ass_reset( );
}

function getFormElement( formName, fieldName )
{
	var el = document.forms[formName].elements;
	var i;
	for ( i = 0; i < el.length; i++ )
	{
		
		if ( el[i].name == fieldName )
			return el[i];
	}
	return null;
}

function progress( myframe, doc, url )
{
	if ( myframe )
	{
		if ( myframe.startProgress )
		{
			myframe.startProgress( doc, url );
		}
		else if ( doc )
			doc.location.href = url;
	}
	else if ( url )
	{
		if (doc) doc.location.href = url;
	}
}

function stop_progress( myframe )
{
	if ( myframe )
		myframe.stopProgress();
}

function go_list(url, skipSave) {
	if (top.main.list.cn3_go_list) {
		try {
			top.main.list.cn3_go_list(url, skipSave);
			return;
		} catch (ex) {
			if (window.console && window.console.warn) {
				window.console.warn('GCN: Inexplicable IE 8 behavior caught.');
			}
		}
	}
	top.main.list.location.href = url;
}

function go_openwindow(url) {
	if (top.main.list.cn3_go_openwindow) {
		try {
			top.main.list.cn3_go_openwindow(url);
			return;
		} catch (ex) {
			if (window.console && window.console.warn) {
				window.console.warn('GCN: Inexplicable IE 8 behavior caught.');
			}
		}
	}
	window.open(url);
}

function evalFormElement( formName, fieldName )
{
	return eval( 'document.forms.'+formName+'.'+fieldName );
}


// get scroll position of window
function get_scrollpos(d) {
	if (!d) d = window;
	var px = 0; 
	var py = 0;
	if (d.document.pageXOffset || d.document.pageYOffset) {
		px = d.document.pageXOffset;
		py = d.document.pageYOffset;
	} else {
		if (d.document.documentElement && (d.document.documentElement.scrollTop || d.document.documentElement.scrollLeft)) {
			px = d.document.documentElement.scrollLeft;
			py = d.document.documentElement.scrollTop;
		} else if (d.document.body) {
			px = d.document.body.scrollLeft;
			py = d.document.body.scrollTop;
		}
	}
	var rs = new Array(px,py);
	return rs;
}

// set scrollPosition of window
function set_scrollpos(px,py) {
	window.scrollTo(px,py);
}

// get Value of a javascript-cookie
function get_cookie(name) {
	var d = document.cookie;
	var p1 = -1;
	var rs = '';
	if (d.substr(0,name.length + 1) == name + '=') {
		p1 = 0;
	} else {
		p1 = d.indexOf('; ' + name + '=');
		if (p1 > -1) p1 = p1 + 2;
	}
	if (p1 > -1) {
		var p2 = d.indexOf('; ',p1);
		if (p2 == -1) p2 = d.length;
		rs = d.substring(p1 + name.length + 1,p2);
	}
	return rs;
}

// set Value of a javascript-Cookie
function set_cookie(name, value) {
	var s = name + '='+value;
	if (top.document.layers) {
		top.document.cookie = s;
	} else {
		document.cookie = s;
	}
}

// get mouse position of last event, must get event variable for netscape
function get_mouse(event) {
	var px = 0; 
	var py = 0;
	if (document.all) {
		var p = get_scrollpos();
		px = window.event.clientX + p[0];
		py = window.event.clientY + p[1];
	} else {
		px = event.pageX;
		py = event.pageY;
	}
	var rs = Array(px,py);
	return rs;
}

// funtion to get coordinates of last click on element
function get_offset(event, element) {
	var px = 0; 
	var py = 0;
	if (document.all) {
		px = window.event.offsetX;
		py = window.event.offsetY;
	} else {
		//TODO: get offset by last abs mouse position and coords of element
		px = event.pageX;
		py = event.pageY;
		while( element != null ) {
		       px -= element.offsetLeft;
		       py -= element.offsetTop;
		       element = element.offsetParent;
		}
	}
	var rs = Array(px,py);
	return rs;
}

// get element by id
function get_element(id) {
	if (document.all) {
		var i = document.all[id];
	} else {
		var i = document.getElementById(id);
	}
	return i;
}

function increase_date_str( dateStr, Years, Months, Days )
{
	if (!window.RegExp) return dateStr;
	
	//date-regex from reg.inc.php
	var reg = new RegExp("^([0-2]?[0-9]|3[0-1])[.:_ /-]([0]?[0-9]|1[0-2])[.:_ /-]([0-9]{2}|[0-9]{4})$","g");
	var parts = reg.exec(dateStr);
	if ( !parts )
		return dateStr;
	if ( parts.length < 4 )
		return dateStr;	
	var tmp;
	var thisDate = new Date( parts[3], parts[2]-1, parts[1] );
	thisDate.setTime( thisDate.getTime() + Days*86400000 );
	if ( Months > 0 )
	{
		tmp = thisDate.getMonth() + Months;
		while ( tmp > 11 )
		{
			Years += 1;
			tmp -= 12;
		}		
		thisDate.setMonth( tmp );
	}
	thisDate.setYear( thisDate.getYear() + Years );
	var year=thisDate.getFullYear();
	if ( year < 999 )
		year += 1900;
	return thisDate.getDate()+'.'+(thisDate.getMonth()+1)+'.'+year; 
}

function decrease_date_str( dateStr, Years, Months, Days )
{
	if (!window.RegExp) return dateStr;
	
	//date-regex from reg.inc.php
	var reg = new RegExp("^([0-2]?[0-9]|3[0-1])[.:_ /-]([0]?[0-9]|1[0-2])[.:_ /-]([0-9]{2}|[0-9]{4})$","g");
	var parts = reg.exec(dateStr);
	if ( !parts )
		return dateStr;
	if ( parts.length < 4 )
		return dateStr;	
		
	var tmp;
	var thisDate = new Date( parts[3], parts[2]-1, parts[1] );
	thisDate.setTime( thisDate.getTime() - Days*86400000 );
	if ( Months > 0 )
	{
		tmp = thisDate.getMonth() - Months;
		while ( tmp < 0 )
		{
			Years += 1;
			tmp += 12;
		}		
		thisDate.setMonth( tmp );
	}
	thisDate.setYear( thisDate.getYear() - Years );
	var year=thisDate.getFullYear();
	if ( year < 999 )
		year += 1900;
	return thisDate.getDate()+'.'+(thisDate.getMonth()+1)+'.'+year; 
}

function changeDate( el, event )
{
	var key, shift, ctrl;
	if ( window.event )
		event = window.event;
	key = event.keyCode;
	shift = event.shiftKey;
	ctrl = event.ctrlKey;

	var day=0, year=0, month=0;

	if ( shift )
		month = 1;
	else if ( ctrl )
		year = 1;
	else
		day = 1;

	if ( key == 38 ) //rauf
		el.value = increase_date_str( el.value, year, month, day );
	else if ( key == 40 ) //runter
		el.value = decrease_date_str( el.value, year, month, day );
	else
	return true;
	return false;
}

function escape_quotes(str)
{
   var ret;
   ret=str.replace(/\\/g,'\\\\');   //escape any backslashs
   ret=str.replace(/\'/g,'\\\'');   //escape any single quotes
   ret=ret.replace(/\"/g,'\\\"');   //escape any double quotes
   return ret;
}

function gtx_getInnerHeight() {
  if (window.innerHeight) {
    return window.innerHeight;
  } else if (document.documentElement && document.documentElement.clientHeight) {
    return document.documentElement.clientHeight;
  } else {
    return document.body.clientHeight;
  }
}
function gtx_getInnerWidth() {
  if (window.innerWidth) {
    return window.innerWidth;
  } else if (document.documentElement && document.documentElement.clientWidth) {
    return document.documentElement.clientWidth;
  } else {
    return document.body.clientWidth;
  }
}


function gtx_getScrollHeight() {
  if (document.body.scrollHeight != undefined) {
    return document.body.scrollHeight + 5;
  }
  if (typeof document.height != "undefined") {
    return document.height;
  }
  if (document.compatMode && document.compatMode != "BackCompat") {
    return document.documentElement.scrollHeight;
  }
  if (document.body && typeof document.body.scrollHeight != "undefined") {
    return document.body.scrollHeight;
  }
}
function gtx_getScrollWidth() {
  if (document.body.scrollWidth != undefined) {
    return document.body.scrollWidth + 15;
  }
  if (typeof document.width != "undefined") {
    return document.width;
  }
  if (document.compatMode && document.compatMode != "BackCompat") {
    return document.documentElement.scrollWidth;
  }
  if (document.body && typeof document.body.scrollWidth != "undefined") {
    return document.body.scrollWidth;
  }
}

function gtx_ass_showtooltip( event, title, text, assTitle ) {
	var tmp = get_mouse(event);
	return gtx_ass_showtooltip( tmp[0], tmp[1], title,text,assTitle );
}

function gtx_ass_showtooltip( mouseX, mouseY, title, text, assTitle ) {
	if (!title || title == 'undefined') title = '';
	if (!text || text == 'undefined') text = '';
	if (!assTitle || assTitle == 'undefined') assTitle = '';
	document.getElementById("listInfos").style.display="block";
	document.getElementById("assHeader").innerHTML = title;
	document.getElementById("assText").innerHTML = text;
	document.getElementById("assItemTitle").innerHTML = assTitle;
	var elem = document.getElementById("listInfos");
	var x = mouseX + 5;
	var y = mouseY + 5;
	var spos = get_scrollpos();
	var width = 0;
	var height = 0; 
	if (self.innerHeight) // all except Explorer
	{
		width = self.innerWidth;
		height = self.innerHeight;
	}
	else if (document.documentElement && document.documentElement.clientHeight)
		// Explorer 6 Strict Mode
	{
		width = document.documentElement.clientWidth;
		height = document.documentElement.clientHeight;
	}
	else if (document.body) // other Explorers
	{
		width = document.body.clientWidth;
		height = document.body.clientHeight;
	}
	var elemwidth = elem.offsetWidth;
	var elemheight = elem.offsetHeight;

	var docwidth = width - 20; // padding of 20px because scrollbars are not counted..
	var docheight = height - 20;

	var spos = get_scrollpos();
	if(x + elemwidth > spos[0] + docwidth) {
		x -= elemwidth + 10;
	}
	if(x < spos[0]) x = spos[0];
	if(y + elemheight > spos[1] + docheight) {
		y -= elemheight + 10;
	}
	if(y < spos[1]) y = spos[1];

	if(x < 1) x = 1;
	if(y < 1) y = 1;
	document.getElementById("listInfos").style.left = x + "px";
	document.getElementById("listInfos").style.top = y + "px";
        document.getElementById("listInfos").style.visibility="visible";
}

function gtx_ass_hidetooltip() {
        document.getElementById("listInfos").style.display="none";
        document.getElementById("listInfos").style.visibility="hidden";
}
