<?php
















global $fileUploader;
?>

<script type="text/javascript">

<?php
if ($fileUploader->isJavascriptInstanceExposed()) {
?>
	var fileUploader = null;
<?php
}

$fileFilters = $fileUploader->getFileFilters();
?>
plupload.addI18n({
	'File extension error.': "<?php echo i18n("fileuploader.error.disallowed_filextension", 0, $fileFilters[0]['title'], $fileFilters[0]['extensions']); ?>"
});

var fileUploader;
$(document).ready(function() {
	plupload.addI18n({
	    'Error: File too large: ': '<?php echo i18n("file upload failed. file must be smaller than {0}.", 0, $fileUploader->getMaxFilesize() . "B"); ?>: '
	});

<?php
if (!$fileUploader->isJavascriptInstanceExposed()) {
?>
	var fileUploader;
<?php
}
?>

	fileUploader = new FileUploader(
	                        $, 
	                        plupload, 
	                        '<?php echo $fileUploader->getButtonOkId();?>',
	                        '<?php echo $fileUploader->getRedirectUrl();?>');

	fileUploader.addI18nKeys({
		'max filesize': "<?php echo i18n("max filesize"); ?>"
	});
	fileUploader.setFileUrlPrefix("<?php echo $fileUploader->getFileUrlPrefix(); ?>");
	fileUploader.setDescriptionElement($(".fileuploader_metadata .fileuploader_description"));
	fileUploader.onSuccess(<?php echo $fileUploader->getJavascriptSuccessCallback(); ?>);
	fileUploader.onError(<?php echo $fileUploader->getJavascriptSuccessCallback(); ?>);
	fileUploader.onFilesAdded(<?php echo $fileUploader->getJavascriptFilesAddedCallback(); ?>);
	fileUploader.setAutomaticUploadEnabled(<?php echo ($fileUploader->getAutomaticUploadEnabled() ? "true" : "false"); ?>);
	fileUploader.initialize(
		$("#<?php echo $fileUploader->getHtmlContainerId(); ?> .fileuploader_plupload"),
		"queue",
		{
			url             : "<?php echo $fileUploader->getUploadUrl(); ?>",
			multipart_params: <?php echo json_encode($fileUploader->getRestMultiPartData()); ?>,
<?php
if (!$fileUploader->getMultiFileEnabled()) {
?>
			multi_selection     : false,
<?php
}

if ($fileUploader->getMaxFilesize() > 0) {
?>
			max_file_size       : '<?php echo $fileUploader->getMaxFilesize(); ?>',
<?php
}

if (!$fileUploader->getMultiFileEnabled()) {
?>
			multiple_queues      : false,
<?php
}
?>
			filters : <?php echo json_encode($fileUploader->getFileFilters()); ?>,

			// Flash settings
			flash_swf_url        : '<?php echo $fileUploader->getPluploadBasePath(); ?>/js/plupload.flash.swf',
			// Silverlight settings
			silverlight_xap_url  : '<?php echo $fileUploader->getPluploadBasePath(); ?>/js/plupload.silverlight.xap'
		}
	);
});

</script>

<div id="<?php echo $fileUploader->getHtmlContainerId(); ?>" class="fileuploader_container<?php echo ($fileUploader->getMultiFileEnabled() ? " fileuploader_multifile" : ""); ?> fileuploader_queue">

	<div class="fileuploader_plupload">
		<p>&nbsp;<p><?php ?>
	</div>

	<div class="fileuploader_metadata">
<?php
if ($fileUploader->getDescriptionEnabled()) {
?>
		<strong><?php echo i18n('305.description'); ?>:</strong><br />
		<br />
		<textarea class="fileuploader_description"><?php echo $fileUploader->getFileDescription(); ?></textarea>
		<br />
		<?php echo i18n('fileupload_description_help'); ?>
<?php
}
?>
	</div>

	<div class="fileuploader_clear"></div>
</div>
