<?php

$HTTP_HEADER = false;
$HTML_HEADER = false;
$HTML_FOOTER = false;
$GZCOMPRESS = false;

GUIFactory::setMainGUI( "shell" );

$SOAP_NAMESPACE = $XNL_SOAP_SERVER_URI.'?wsdl';


$server = new soap_server();
$server->configureWSDL('Gentics .Node XNL SOAP Service',$SOAP_NAMESPACE,$XNL_SOAP_SERVER_URI);

$server->wsdl->schemaTargetNamespace = $SOAP_NAMESPACE;

node_include('xnlparser');










function xnl_call ($func, $params) {
 global $XNL_FUNCTION;
 $xnlloader = new XNLLoader($XNL_FUNCTION);
 $xnlloader->fetchPackages();
 $requestor = new XNLRequest($xnlloader);
 $parser = new XNLParser();
 $parser->setShowErrors(true);
 $parser->setEvaluate(true);
 $funcparser = new XNLFunctionParser($requestor);
 $funcparser->setParser($parser);
 $funcparser->setKeyname($func);
 foreach ($params as $name => $value) {
 $code .= "<$name>$value</$name>";
 }
 $a_ret = $funcparser->parse($code, array());
 if (!is_array($a_ret)) $a_ret = Array($a_ret);
 foreach ($a_ret as $obj) {
 if (is_a($obj, 'eMessage')) {
 return new soap_fault('Server','','XNL Error: '.$obj->getMessage());
 } else {
 $ret .= $obj->toString();
 }
 }

 return new soapval('content','xsd:string',$ret);
}


$xnlloader = new XNLLoader($XNL_FUNCTION);
$packages = $xnlloader->getPackages();
while (list($package,$elements) = each($packages)) {
 $connect = $xnlloader->getConnect($package);
 $functions = $xnlloader->getFunctions($package);
 foreach ($functions as $function => $properties) {
 $input = Array();
 unset($params);
 $param_to_array = '$params = Array();'."\n";
 foreach($properties['params'] as $param => $declarations) {
 $input[$param] = 'xsd:string';
 if ($params) $params .= ', ';
 $params .= "\$$param";
 $params .= " = '".$declarations['default']."'";
 $param_to_array .= "	\$params['$param']  = \$$param;\n";
 }
 $function_code = "
function xnl_$function ($params) {
	$param_to_array
	return xnl_call('$function', \$params);
}
";
 eval($function_code);
 $server->register(
 "xnl_$function",
 $input,
 array('content'=>'xsd:string'),
 $XNL_SOAP_SERVER_URI,
 $XNL_SOAP_SERVER_URI);
 }
}

if (count($packages) == 0) {
 $server->register(
 "no_xnl_function_available",
 array('input'=>'xsd:string'),
 array('msg'=>'xsd:string'),
 $XNL_SOAP_SERVER_URI,
 $XNL_SOAP_SERVER_URI);
}

function no_xnl_function_available($input) {
 return new soapval('msg','xsd:string','No XNL Function available. ('.$input.')');
}


$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);

?>
