<?

ConsistencyFactory::register(new SQLConsistencyObject("user_group_user",
 "SELECT id FROM systemuser LEFT JOIN user_group ON user_group.user_id = systemuser.id WHERE user_group.user_id IS NULL AND systemuser.active = 1",
 "all active users in one group"));

ConsistencyFactory::register(new SQLConsistencyObject("user_group_group",
 "SELECT usergroup_id FROM user_group LEFT JOIN usergroup ON user_group.usergroup_id = usergroup.id WHERE usergroup.id IS NULL",
 "all user_group-connections to existing group"));

global $SQLAS;
ConsistencyFactory::register(new SQLConsistencyObject("usergroup",
 "SELECT usergroup.id, usergroup.mother FROM usergroup LEFT JOIN usergroup $SQLAS u ON u.id = usergroup.mother WHERE u.id IS NULL AND usergroup.mother > 0",
 "all groups have existing mother"));

ConsistencyFactory::register(new SQLConsistencyObject("tree",
 "SELECT tree.id, tree.mother FROM tree LEFT JOIN tree $SQLAS t ON t.id = tree.mother WHERE t.id IS NULL AND tree.mother > 0",
 "all tree-entries have mothers"));

?>
