<?

define("PAGE_STATUS_MODIFIED", 0);

















function page_exists($name,$filename,$pub_dir,$node_id,$folder_id,$id = 0,$contentset_id = 0) {

 global $ERROR, $DIC, $FEATURE, $NODE_ID;




 $pub_dir = sqlslashes($pub_dir);
 $filename = sqlslashes($filename); 

 
 
 
 $cs_id = 0;
 if ($id) {
 $info = get_pageinfo($id);
 $cs_id = $info["contentset_id"];
 
 $channelset_id = $info["channelset_id"];
 } elseif ($contentset_id) {
 $cs_id = $contentset_id;
 }

 
 if (!empty($filename)) {
 
 $sql = "SELECT id FROM folder WHERE pub_dir = '".sqlf_escaped($pub_dir)."' AND node_id = ".sqlf_tl_num($node_id);
 $rs = query($sql);
 
 $keys = "-1";
 if ($rs["arr"])
 while (list($key,$row) = each($rs["arr"])) {
 $keys .= ",".sqlf_tl_num($row["id"]);
 }
 
 
 
 $sql = "SELECT id, name, folder_id, channelset_id, channel_id FROM page"
 . " WHERE page.filename = '".sqlf_escaped($filename)."' AND page.folder_id IN ($keys) AND page.id != ".sqlf_tl_num($id);
 if ($channelset_id) {
 
 $sql .= " AND page.channelset_id != ".sqlf_tl_num($channelset_id);
 }
 $rs2 = query($sql);
 
 
 
 if ($rs2["num"]) {
 if ($FEATURE["multichannelling"]) {
 
 while(list($rs2_key, $rs2_val) = each($rs2["arr"])) {
 if ($rs2_val["channelset_id"]) {
 $fb = doMultichannellingFallback(T_PAGE, $rs2_val["channelset_id"], $NODE_ID);
 if ($fb && $fb["id"] != $rs2_val["id"]) {
 continue;
 }
 }
 
 
 
 $old_node_id = $NODE_ID;
 if ($rs2_val["channel_id"]) {
 $NODE_ID = $rs2_val["channel_id"];
 }
 $folderinfo = get_folderinfo($rs2_val["folder_id"], true);
 $fullpath = $folderinfo["fullpath"]["name"] . '/' . $rs2_val["name"];
 $ERROR["filename"] = i18n("A page with this filename already exists", 0, $fullpath);
 
 $NODE_ID = $old_node_id;
 return true;
 }
 } else {
 
 $folderinfo = get_folderinfo($rs2["arr"][0]["folder_id"], true);
 $fullpath = $folderinfo["fullpath"]["name"] . '/' . $rs2["arr"][0]["name"];
 $ERROR["filename"] = i18n("A page with this filename already exists", 0, $fullpath);
 return true;
 }
 }
 
 
 
 
 
 $sql_publish = "SELECT page_id FROM publish WHERE filename='".sqlf_escaped($filename)."' AND folder_id IN ($keys) and page_id != ".sqlf_tl_num($id);
 $rs_publish = query($sql_publish);
 while (list($key, $row) = each($rs_publish["arr"])) {
 $conflict_id = $row["page_id"];
 
 
 
 $conflict_details = get_pageinfo($conflict_id);
 if ($conflict_details === false) {
 
 continue;
 }
 if (($conflict_details["status"] == 1 || $conflict_details["status"] == 3) && ($conflict_details["folder_id"] != $folder_id || $conflict_details["filename"] != $filename)) {
 continue;
 } else if ($channelset_id && ($conflict_details["channelset_id"] == $channelset_id)) {
 
 continue;
 } else {
 $folderinfo = get_folderinfo($conflict_details["folder_id"], true);
 $fullpath = $folderinfo["fullpath"]["name"] . '/' . $conflict_details["name"];
 $ERROR["filename"] = i18n("A <em>published</em> page with this filename already exists:<br/> {0}", 0, $fullpath);
 return true;
 }
 }
 }

 
 


 if ( $name !== false ) {
 $name = sqlslashes($name);
 $sql = "SELECT count(page.id) AS c FROM page, folder WHERE page.name = '".sqlf_escaped($name)."' AND page.id != ".sqlf_tl_num($id)." AND page.folder_id = ".sqlf_tl_num($folder_id);
 if ($cs_id) $sql .= " AND page.contentset_id != ".sqlf_tl_num($cs_id);
 if ($channelset_id) {
 
 $sql .= " AND page.channelset_id != ".sqlf_tl_num($channelset_id);
 }
 if ($FEATURE["multichannelling"]) {
 $relatedChannels = getRelatedChannels($NODE_ID);
 $relatedChannels []= $NODE_ID;
 $relatedString = implode(",", $relatedChannels);
 $sql .= " AND case when page.channel_id = 0 then folder.node_id else page.channel_id end in ($relatedString)";
 }
 $rs = query($sql);
 if ($rs["arr"][0]["c"] > 0) {
 $ERROR["name"] = i18n('a_page_with_this_name');
 return true;
 }
 }

 return false;

}





















function cmd_page_create($name,$desc,$priority,$filename,$template_id,$folder_id,$contentgroup_id=0,$contentset_id=0, $force_extension = false, $channel_id = false) {

 global $TIME, $USER_ID, $ERROR, $W_CREATE, $T_PAGE, $CONTENT_ID, $FEATURE, $NODE_ID;

 
 $folder = new CNFolderObject($folder_id);
 $folder_id = $folder->getMasterId();

 $sql = "SELECT node_id, pub_dir FROM folder WHERE id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);
 $node_id = $rs["arr"][0]["node_id"];
 $pub_dir = $rs["arr"][0]["pub_dir"];

 if ($filename && !$force_extension) {
 $sql = "SELECT ml.ext FROM template, ml WHERE template.ml_id = ml.id AND template.id = ".sqlf_tl_num($template_id);
 $rs = query($sql);
 if (!ereg("\.".$rs["arr"][0]["ext"]."$",$filename)) {
 $filename = cutFilenameForExtension($filename, strlen($rs["arr"][0]["ext"])) . "." . $rs["arr"][0]["ext"];
 }
 }
 
 if (page_exists($name,$filename,$pub_dir,$node_id,$folder_id,0,$contentset_id)) {
 return false;
 }


 
 
 node_include("contentgroup");
 if ($CONTENT_ID) {
 $content_id = $CONTENT_ID; 
 } else {
 $content_id = get_contentId_for_contentset($contentset_id, $contentgroup_id);
 if (!$content_id) {
 $sql = "INSERT INTO content (node_id,creator,cdate,editor,edate)
VALUES (".sqlf_tl_num($node_id).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).")";
 $rs = query($sql);
 $content_id = $rs["iid"];
 }
 }

 if (!$content_id) halt(7,"cmd_page_create: insert of content failed: content_id($content_id)");

 $a_name = sqlslashes($name);
 $a_desc = sqlslashes($desc);
 $a_filename = sqlslashes($filename);
 
 if (!$contentgroup_id) $contentgroup_id = 0;
 if (!$contentset_id && ($FEATURE["contentgroup3"]||$FEATURE["contentgroup"])) $contentset_id = cmd_page_createcs(); 
 if ( !$FEATURE["contentgroup"] && !$FEATURE["contentgroup3"] ) {
 $contentgroup_id = 0;
 $contentset_id = 0;
 }
 if ( $contentgroup_id == 0 ) $contentset_id = 0;

 
 if ($FEATURE["multichannelling"] && $channel_id === false) {
 $folderinfo = get_folderinfo($folder_id);
 $channel_id = $folderinfo["node_id"] != $NODE_ID ? $NODE_ID : 0;

 
 $masterNodes = getMasterNodes($channel_id);
 if (!in_array($folderinfo["node_id"], $masterNodes)) {
 
 $channel_id = 0;
 }
 } else if (!$FEATURE["multichannelling"]) {
 $channel_id = 0;
 }

 
 $channelsetId = createChannelsetId();

 
 $sql = "INSERT INTO page (name,description,filename,template_id,priority,content_id,folder_id,creator,cdate,editor,edate,contentgroup_id, contentset_id, channel_id, channelset_id)
VALUES ('$a_name','$a_desc','$a_filename',".sqlf_tl_num($template_id).",".sqlf_tl_num($priority).",".sqlf_tl_num($content_id).",".sqlf_tl_num($folder_id).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($USER_ID).",".sqlf_tl_num($TIME).",".sqlf_tl_num($contentgroup_id).",".sqlf_tl_num($contentset_id).", ".sqlf_tl_num($channel_id).", ".sqlf_tl_num($channelsetId).")";
 $rs = query($sql);
 $page_id = $rs["iid"];


 if ($name == "") {
 $name = $page_id;
 $sql = "UPDATE page SET name = \"".sqlslashes($name)."\" WHERE id = ".sqlf_tl_num($page_id);
 query($sql);
 }


 if (!$filename) {
 $sql = "SELECT ml.ext FROM template LEFT JOIN ml ON (template.ml_id = ml.id) WHERE template.id = " . sqlf_tl_num($template_id);
 $rs = query($sql); 
 $ext = $rs["arr"][0]["ext"];

 if ( $FEATURE["get_filename_as_pagename"] ) {
 
 $filename = convertToFilename($name . "." . $ext);

 
 if (strlen($filename) == 0) {
 $filename = $page_id;
 }
 } else {
 $filename = $page_id . "." . $ext;
 }

 
 if ($FEATURE["contentgroup3_pagefilename"] && $contentgroup_id) {
 
 $folder_info = get_folderinfo($folder_id);
 $cg = get_contentgroups($folder_info["node_id"]);

 if ($FEATURE["contentgroup3_pagefilename_no_apachefilename"]) {
 preg_match ("/(.*)\.([^\.]*)$/", $filename, $fparts);
 
 
 $fnamelength = 62 - 4  - strlen($cg[$contentgroup_id]["code"]) - strlen($fparts[2]);
 $filename = substr( $fparts[1], 0, $fnamelength ) . '.' . $cg[$contentgroup_id]["code"] . '.' . $fparts[2];
 } else {
 $filename .= ".".$cg[$contentgroup_id]["code"];
 }
 }

 
 if ( page_exists( $name, $filename, $pub_dir, $node_id, $folder_id, $page_id ) ) {
 if ( $FEATURE["get_filename_as_pagename"] && !$FEATURE["contentgroup3_pagefilename"] ) {
 $filename = $filename.".".$page_id.".".$ext; 
 }

 $filename = unique_page_filename($filename, $folder_id, $page_id);
 }

 $a_filename = sqlslashes($filename);
 $sql = "UPDATE page SET filename = '$a_filename' WHERE id = ".sqlf_tl_num($page_id);
 query($sql);
 }


 tag_copy($template_id,"template",$content_id,"content");

 global $T_FOLDER;
 
 logcmd($W_CREATE,$T_PAGE,$page_id,$folder_id,"cmd_page_create");
 triggerEvent( $T_PAGE, $page_id, EVENT_CREATE, new EventObject() );
 
 
 trigger_event("onpagecreate",
 array("page_id"=>$page_id,"folder_id"=>$folder_id));

 
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_FOLDER, $folder_id);

 return $page_id;
}

function cmd_page_del_all_versions( $ids ) {
 global $T_PAGE;
 while (list($id,$val) = each($ids)) {
 node_class("cnpageobject");
 $pageobject = new CNPageObject($id);
 logcmd( W_DELALLVERSIONS, $T_PAGE, $id, 0, '' );
 $pageobject->deleteAllVersions();
 }
}








function cmd_page_del_wf($ids, $all_contentgroups = false, $forcelang = false) {
 global $T_PAGE, $W_DEL, $USER_ID, $CONTENTGROUP_ID, $FEATURE, $DEBUG;

 if (!is_array($ids)) halt(7,"cmd_page_del: not a valid array: ids($ids)");

 $del_ids = array();
 while (list($id,$val) = each($ids)) {
 if ($all_contentgroups) {
 if ($FEATURE['workflow_event_onpagedelete_all_lang']) {
 
 if (trigger_event("onpagedelete_all_lang", array("page_id" => $id))) {
 continue;
 }
 }
 
 $sql = "SELECT contentset_id, channel_id FROM page WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 
 if ($rs["arr"][0]["contentset_id"]) {
 $sql = "SELECT id FROM page WHERE contentset_id = ".sqlf_tl_num($rs['arr'][0]["contentset_id"])." AND channel_id = ".sqlf_tl_num($rs['arr'][0]["channel_id"]);
 $rs = query($sql);
 $pids = reduce_array($rs['arr'], 'id', 'id');
 $del_ids = array_merge($del_ids, cmd_page_del_wf($pids, false, true));
 continue;
 }
 } else {
 $page = get_pageinfo($id);
 
 
 if (!$forcelang && (!isset($page["contentgroup_id"]) || $page["contentgroup_id"] != $CONTENTGROUP_ID)) {
 continue;
 }
 }

 
 if (trigger_event("onpagedelete",array("page_id"=>$id))) {
 continue;
 } else {
 $del_ids[] = $id;
 }
 }
 return $del_ids;
}








function cmd_page_del($ids, $all_contentgroups = false, $forcelang = false) {

 global $T_PAGE, $W_DEL, $USER_ID, $CONTENTGROUP_ID, $FEATURE, $DEBUG, $ERROR, $JAVAPARSER_RETURN;

 if (!is_array($ids)) halt(7,"cmd_page_del: not a valid array: ids($ids)");

 
 $wf_ids = cmd_page_del_wf($ids, $all_contentgroups, $forcelang);
 $del_ids = array();

 while (list($key, $id) = each($wf_ids)) {
 if ($all_contentgroups) {
 $sql = "SELECT contentset_id, channel_id FROM page WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);

 
 if ($rs["arr"][0]["contentset_id"]) {
 $sql = "SELECT id FROM page WHERE contentset_id = ".sqlf_tl_num($rs['arr'][0]["contentset_id"])." AND channel_id = ".sqlf_tl_num($rs['arr'][0]["channel_id"]);
 $rs = query($sql);
 $pids = reduce_array($rs['arr'], 'id', 'id');
 $del_ids = array_merge($del_ids, $pids);
 } else {
 $del_ids[$id] = $id;
 }
 } else {
 $page = get_pageinfo($id);
 
 
 if (!$forcelang && (!isset($page["contentgroup_id"]) || $page["contentgroup_id"] != $CONTENTGROUP_ID)) {
 continue;
 } else {
 $del_ids[$id] = $id;
 }
 }
 }

 $error = false;
 if (!empty($del_ids)) {
 
 $javaParser =& CodeParser::getJavaParser();
 $ERROR = $javaParser->deleteObject(T_PAGE, $del_ids);
 if (!empty($ERROR)) {
 $error = true;
 if (isset($JAVAPARSER_RETURN["params"]["halt"])) {
 halt(7, $ERROR);
 }
 }
 }

 return $error;
}






function page_is_inherited($ids) {
 global $FEATURE, $NODE_ID;

 if (!$FEATURE["multichannelling"]) {
 return false;
 }

 if (is_array($ids) && count($ids) > 0) {
 $nodeinfo = get_nodeinfo($NODE_ID);
 
 if ($nodeinfo["master_id"] > 0) {
 $sql = "SELECT count(*) c FROM page WHERE id IN (".sqlf_value_list(implode(",", array_keys($ids))).") AND channel_id != ".sqlf_tl_num($NODE_ID);
 $rs = query($sql);
 return $rs["arr"][0]["c"] > 0;
 } else {
 
 return false;
 }
 } else {
 return false;
 }
}







function page_has_localized_copy($ids, $all_contentgroups = false) {
 global $FEATURE;

 if (!$FEATURE["multichannelling"]) {
 return false;
 }

 if (is_array($ids) && count($ids) > 0) {
 if ($all_contentgroups) {
 
 $sql = "SELECT count(*) c FROM page p1 left join page p2 ON p1.channelset_id = p2.channelset_id WHERE p1.id in (".
 sqlf_value_list(implode(",", array_keys($ids))).") AND p1.is_master = 1 and p2.is_master = 0";
 $rs = query($sql);
 
 if ($rs["arr"][0]["c"] > 0) {
 return true;
 }

 
 $sql = "SELECT count(*) cnt FROM page a ".
 "LEFT JOIN page b ON a.channelset_id = b.channelset_id " .
 "LEFT JOIN page c ON b.contentset_id = c.contentset_id " .
 "WHERE c.id IN (".sqlf_value_list(implode(",", array_keys($ids))).") " .
 "AND c.contentset_id != 0 " .
 "AND c.is_master = 1 " .
 "AND b.is_master = 1 " .
 "AND a.is_master = 0";

 $rs = query($sql);
 return $rs["arr"][0]["cnt"] > 0;
 } else {
 
 $sql = "SELECT count(*) c FROM page p1 left join page p2 ON p1.channelset_id = p2.channelset_id WHERE p1.id in (".
 sqlf_value_list(implode(",", array_keys($ids))).") AND p1.is_master = 1 and p2.is_master = 0";
 $rs = query($sql);
 return $rs["arr"][0]["c"] > 0;
 }
 } else {
 
 return false;
 }
}







function cmd_page_switch_template($id, $template_id, $synctags) {

 global $FEATURE;
 $ids = is_array($id) ? $id : array($id);
 $pages = array();
 foreach ($ids as $id) {
 $sql = "SELECT id, name, description, priority, filename, template_id, status, contentset_id, contentgroup_id, content_id, channel_id FROM page WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql);
 if ( $FEATURE["contentgroup3"] && $rs["arr"][0]["contentset_id"] > 0) {
 $sql = "SELECT id, name, content_id, description, priority, filename, template_id, status, contentgroup_id FROM page WHERE contentset_id = ".sqlf_tl_num($rs["arr"][0]["contentset_id"])." AND channel_id = ".sqlf_tl_num($rs["arr"][0]["channel_id"]);
 $rs = query($sql);
 foreach ($rs["arr"] as $lang_variant) {
 $pages[] = $lang_variant["id"];
 }
 } else {
 $pages[] = $id;
 }
 }
 global $ERROR;
 $javaParser =& CodeParser::getJavaParser();
 $ERROR = $javaParser->changeTemplate($pages, $template_id, $synctags);
 if (!empty($ERROR)) {
 $error = true;
 if (isset($JAVAPARSER_RETURN["params"]["halt"])) {
 halt(7, $ERROR);
 }
 }
 return $error;
}

function cmd_page_update($id,$name,$desc,$priority,$filename,$template_id,$status,$contentgroup) {

 global $TIME, $USER_ID, $T_PAGE,$W_EDIT, $T_FOLDER, $FEATURE;

 
 $modified = array();

 $sql = "SELECT folder.id, folder.node_id, folder.pub_dir, page.template_id, page.name, page.description, page.priority, 
  page.priority, page.filename, page.status, page.contentgroup_id, page.content_id FROM folder, page
WHERE page.folder_id = folder.id AND page.id = ".sqlf_tl_num($id);
 $rs = query($sql);
 $pub_dir = $rs["arr"][0]["pub_dir"];
 $node_id = $rs["arr"][0]["node_id"];
 $folder_id = $rs["arr"][0]["id"];
 $old_page = $rs["arr"][0];

 
 if ($name != $old_page["name"]) {
 $modified[] = "name";
 }
 if ($desc != $old_page["description"]) {
 $modified[] = "description";
 }
 if ($priority != $old_page["priority"]) {
 $modified[] = "priority";
 }
 if ($template_id != $old_page["template_id"]) {
 $modified[] = "template";
 
 }
 if ($contentgroup != $old_page["contentgroup_id"] && ($FEATURE["contentgroup"] || $FEATURE["contentgroup3"])) {
 
 }

 
 $old_template = get_templateinfo($rs["arr"][0]["template_id"]);
 $new_template = get_templateinfo($template_id);
 $old_ml = get_mlinfo($old_template["ml_id"]);
 $new_ml = get_mlinfo($new_template["ml_id"]);
 $old_ext = $old_ml["ext"];
 $new_ext = $new_ml["ext"];
 if ($old_ext != $new_ext) $filename = ereg_replace("\.$old_ext$",".$new_ext",$filename);


 
 if (!$filename) {
 $sql = "SELECT ml.ext FROM template, ml WHERE template.ml_id = ml.id AND template.id = " . sqlf_tl_num($template_id);
 $rs = query($sql);
 $ext = $rs["arr"][0]["ext"];

 if ($FEATURE["get_filename_as_pagename"]) {
 
 $filename = convertToFilename($name . '.' . $ext);
 } else {
 $filename = $id . "." . $ext;
 }

 
 $new_contentgroup = $contentgroup ? $contentgroup : $old_page["contentgroup_id"];
 if ($FEATURE["contentgroup3_pagefilename"] && $new_contentgroup) {
 
 $folder_info = get_folderinfo($folder_id);
 $cg = get_contentgroups($folder_info["node_id"]);

 if ($FEATURE["contentgroup3_pagefilename_no_apachefilename"]) {
 preg_match ("/(.*)\.([^\.]*)$/", $filename, $fparts);
 
 
 $fnamelength = 62 - 4  - strlen($cg[$new_contentgroup]["code"]) - strlen($fparts[2]);
 $filename = substr( $fparts[1], 0, $fnamelength ) . '.' . $cg[$new_contentgroup]["code"] . '.' . $fparts[2];
 } else {
 $filename .= ".".$cg[$new_contentgroup]["code"];
 }
 }

 }

 
 if (!strpos($filename,".",1)) {
 $filename = cutFilenameForExtension($filename, strlen($new_ext)) . '.' . $new_ext;
 }

 if (page_exists($name,$filename,$pub_dir,$node_id,$folder_id,$id)) return false;

 if ($status == 2) {
 if (perm($USER_ID,$T_FOLDER,$folder_id,19)) $status = 1;
 else $status = 4;
 }
 if ($status == 5) $status = 0;
 
 
 if ($old_page["name"] == $name && $old_page["description"] == $desc && $old_page["priority"] == $priority && 
 $old_page["filename"] == $filename && $old_page["template_id"] == $template_id && 
 ($old_page["contentgroup_id"] == $contentgroup || (!$FEATURE["contentgroup"] && !$FEATURE["contentgroup3"]))) return false;

 
 if ($filename != $old_page["filename"]) {
 $modified[] = "filename";
 }

 page_status($id,$status,$USER_ID);

 $name = sqlslashes($name);
 $description = sqlslashes($desc);
 $filename = sqlslashes($filename);

 if ( ($FEATURE["contentgroup"] || $FEATURE["contentgroup3"]) && $contentgroup )
 $dbcontentgroup =", contentgroup_id = ".(int)$contentgroup;
 
 $sql = "UPDATE page SET name = '$name', description = '$description', priority = ".sqlf_tl_num($priority).", filename = '$filename', 
editor = ".sqlf_tl_num($USER_ID).", edate = ".sqlf_tl_num($TIME).", template_id = ".sqlf_tl_num($template_id).", status = ".sqlf_tl_num($status)." $dbcontentgroup
WHERE id = ".sqlf_tl_num($id);
 query($sql);

 logcmd($W_EDIT,$T_PAGE,$id,$folder_id,"cmd_page_update");
 triggerEvent( $T_PAGE, $id, EVENT_UPDATE, 
 new EventObject( array( "name"=>$name, "description"=>$description, "priority"=>$priority,
 "filename"=>$filename, "editor"=>$USER_ID, "template_id"=>$template_id, "status"=>$status ) ) );

 
 if ($FEATURE["javaparser"]) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_PAGE, $id);
 }

 return $id;

}

function cmd_page_time_update($page_id,$from,$to,$weekdays,$pub = false) {
 
 global $TIME, $USER_ID, $T_PAGE, $FEATURE;

 if (!$page_id) halt(7,"cmd_page_time_update: No Page_id. page_id($page_id)");

 if (!$from) $from = 0;
 if (!$to) $to = 0;
 if (in_array(1,$weekdays)) $w1 = 1; else $w1 = 0;
 if (in_array(2,$weekdays)) $w2 = 1; else $w2 = 0;
 if (in_array(3,$weekdays)) $w3 = 1; else $w3 = 0;
 if (in_array(4,$weekdays)) $w4 = 1; else $w4 = 0;
 if (in_array(5,$weekdays)) $w5 = 1; else $w5 = 0;
 if (in_array(6,$weekdays)) $w6 = 1; else $w6 = 0;
 if (in_array(7,$weekdays)) $w7 = 1; else $w7 = 0;

 $page = get_pageinfo($page_id);

 $sql = "UPDATE page SET time_start = ".sqlf_tl_num($from).", time_end = ".sqlf_tl_num($to).", time_mon = $w1, time_tue = $w2, time_wed = $w3, time_thu = $w4, time_fri = $w5, time_sat = $w6, time_sun = $w7 ".($pub !== false ? ", time_pub = ".sqlf_tl_num($pub) : "")." WHERE id = ".sqlf_tl_num($page_id);
 query($sql);

 if ($pub !== false && $page["time_pub"] != $pub) {
 page_status($page_id, 0);
 }

 cmd_page_settimestate($page_id);

 
 if ($FEATURE["javaparser"]) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_PAGE, $page_id);
 }

 return true;
}


function cmd_page_settimestate($page_id) {
 
 global $TIME;

 if (!$page_id) halt(7,"cmd_page_settimestate: No page_id! page_id($page_id)");

 $sql = "SELECT time_pub, editor, publisher, status, time_start, time_end, time_mon, time_tue, time_wed, time_thu, time_fri, time_sat, time_sun FROM page WHERE id = ".sqlf_tl_num($page_id);
 $rs = query($sql);
 if (!$rs["arr"]) return false;
 $r = $rs["arr"][0];

 $day = strtolower(date("D",$TIME));

 $active = $r["time_$day"];

 
 if ($r["time_pub"] > 0 && $r["time_pub"] < $TIME && ($r["status"] == 0 || $r["status"] == 3)) {
 cmd_page_pub($page_id);
 $sql = "select status from page where id = ".sqlf_tl_num($page_id);
 $rs = query($sql);
 $r["status"] = $rs["arr"][0]["status"];
 $sql = "UPDATE page SET time_pub = 0 WHERE id = ".sqlf_tl_num($page_id);
 query($sql);
 }

 if ($r["time_start"] <= $TIME && ($r["time_end"] > $TIME || $r["time_end"] <= 0) && $active) $state = 1; else $state = 5;

 

 if ($r["time_start"] != 0 && (($state == 5 && ($r["status"] == 2 || $r["status"] == 1)) || ($state == 1 && $r["status"] == 5))) { 
 page_status($page_id,$state,$r["publisher"]);



 
 return $state;
 } return false;
}










function cmd_page_move($source, $target, $uid=0, $all_contentgroups = true, $target_node_id = 0) {
 global $USER_ID, $TIME, $DIC, $W_MOVE, $T_FOLDER, $ERROR, $T_PAGE, $FEATURE, $T_DOMAIN_CHANNEL;

 if (!$source) halt(0,"cmd_page_move: No source to move");
 if (!$target) halt(0,"cmd_page_move: No target to move");
 
 if (!$uid) $uid = $USER_ID;

 
 if (!class_exists('CNFolderObject')) {
 node_class("cnfolderobject");
 }

 $folder = new CNFolderObject($target);
 if (!$target_node_id) {
 $folderinfo = get_folderinfo($target);
 $target_node_id = $folderinfo["channel_id"];
 }
 $target = $folder->getMasterId();

 
 $folderinfo = get_folderinfo($target);

 $node_id = $folderinfo["node_id"];
 $pub_dir = $folderinfo["pub_dir"];

 if ($target_node_id) {
 $target_nodeinfo = get_nodeinfo($target_node_id);
 }

 if (!is_array($source)) {
 $source = array($source => true);
 }

 
 $source = array_unique(array_keys($source));

 
 
 if ($FEATURE["multichannelling"]) {
 
 $sql = "SELECT id FROM page WHERE id IN (".sqlf_value_list(implode(",", $source)).") AND is_master = 1";
 $rs = query($sql);
 $cleansource = array();
 foreach ($rs["arr"] as $row) {
 $cleansource[$row["id"]] = true;
 }

 $source = array_keys($cleansource);

 
 if (count($source) == 0) {
 return false;
 }
 }

 
 foreach ($source as $page_id) {
 if ( ! perm_can_move_page($page_id) ) {
 $page_info = get_pageinfo($page_id);
 $folder_info = get_folderinfo($page_info['folder_id'], true);
 $page_path = implode('/', $folder_info['fullpath']) . '/' . $page_info['name'];
 $ERROR = i18n('error.perm.pagemove.sourceremove', 0, $page_path);
 return true;
 }
 }

 
 if (!perm($uid,$T_FOLDER,$target,12)) {
 foreach ($source as $key) {
 $sql = "SELECT contentgroup_id,contentset_id FROM page where id = '".sqlf_escaped($key)."'";
 $rs = query( $sql );
 foreach( $rs['arr'] as $row ) {
 if ($all_contentgroups && $row['contentset_id']) {
 
 $sql = "SELECT contentgroup_id FROM page where contentset_id = '".sqlf_escaped($row['contentset_id'])."'";
 $rs1 = query( $sql );
 foreach( $rs1['arr'] as $row1 ) {
 if (!perm($uid,$T_FOLDER,$target,12,$row1['contentgroup_id'], $T_PAGE, 11)) {
 $ERROR = i18n('851.you_have_no_permission_to');
 return true;
 }
 }
 } else {
 if (!perm($uid,$T_FOLDER,$target,12,$row['contentgroup_id'], $T_PAGE, 11)) {
 $ERROR = i18n('851.you_have_no_permission_to');
 return true;
 }
 }
 }
 }
 }

 if ($all_contentgroups) {
 foreach ($source as $key) {
 $sql = "SELECT contentset_id FROM page WHERE id = ".sqlf_tl_num($key)." AND contentset_id != 0";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 
 $sql = "SELECT id FROM page WHERE contentset_id = ".sqlf_tl_num($rs['arr'][0][0])." AND is_master = 1";
 $rs = query($sql);
 $pids = reduce_array($rs['arr'], 'id', 'id');
 } else {
 $pids = Array();
 $pids[$key] = true;
 }
 if ($err = cmd_page_move($pids, $target, $uid, false, $target_node_id)) {
 
 
 
 $error = $err;
 }
 }
 return $error;
 }

 
 $sql = "SELECT id, folder_id, name, filename, contentgroup_id, channel_id, channelset_id, is_master"
 . " FROM page"
 . " WHERE id IN (" . implode(",", sqlf_tl_num_array($source)) . ")";
 $rs = query($sql);
 $move = $rs["arr"];

 
 
 
 $sql = "SELECT COUNT(id) conflict"
 . " FROM page"
 . " WHERE id IN (" . implode(",", sqlf_tl_num_array($source)) . ")"
 . " GROUP BY name"
 . " HAVING COUNT(DISTINCT contentset_id) > 1";
 $rs = query($sql);
 if ($rs['arr'][0]['conflict']) {
 $ERROR = i18n('There exists a duplicate page name among the pages to be moved.');
 return true;
 }

 
 if ( $FEATURE["page_move_error_on_duplicate_filename"]
 && ! is_unique_db_column_ci($move, "filename")) {
 $ERROR = i18n("There exists a duplicate filename among the pages to be moved.");
 return true;
 }

 
 $sql = "SELECT distinct p2.id, p2.folder_id, p2.name, p2.filename, p2.contentgroup_id, p2.channel_id, p2.channelset_id, p2.is_master FROM page p1 ".
 "LEFT JOIN page p2 ON p1.channelset_id = p2.channelset_id WHERE p1.id IN (". implode(",", sqlf_tl_num_array($source)) .") AND p2.is_master = 0";

 $rs = query($sql);
 $move = array_merge($move, $rs["arr"]);

 
 
 
 foreach ($move as $key => $page) {
 
 if ($page["folder_id"] == $target && $page["channel_id"] == $target_node_id) {
 unset($move[$key]);
 continue;
 }

 
 
 
 if (page_exists(false, $page["filename"], $pub_dir, $node_id, $target, $page["id"])) {
 if ($FEATURE["page_move_error_on_duplicate_filename"]) {
 $ERROR = $ERROR["filename"] ? $ERROR["filename"] : $ERROR["name"];
 return true;
 }
 
 
 $page["filename"] = unique_page_filename($page["filename"], $target, $page["id"]);
 
 $move[$key] = $page;
 }

 
 
 if (page_exists($page["name"], $page["filename"], $pub_dir, $node_id, $target, $page["id"])) {
 
 $ERROR = $ERROR["filename"] ? $ERROR["filename"] : $ERROR["name"];
 return true;
 }
 }

 
 
 
 $double_check_filenames = ! is_unique_db_column_ci($move, "filename");

 
 $ignore_user_abort = ignore_user_abort(true);

 node_class("cnpageobject");
 $javaParser =& CodeParser::getJavaParser();

 foreach ($move as $page) {
 
 if (trigger_event("onpagemove", array("page_id" => $page["id"], "to_folder_id" => $target))) {
 continue;
 }

 $pageinfo = get_pageinfo($page["id"]);
 
 if (!$page["is_master"]) {
 if ($pageinfo["node_id"] != $node_id) {
 $ERROR = $javaParser->deleteObject(T_PAGE, $pageinfo["id"]);
 if (!empty($ERROR)) {
 $error = true;
 if (isset($JAVAPARSER_RETURN["params"]["halt"])) {
 halt(7, $ERROR);
 }
 }
 continue;
 }
 }

 if ($double_check_filenames) {
 
 
 if (page_exists($page["name"], $page["filename"], $pub_dir, $node_id, $target, $page["id"])) {
 $page["filename"] = unique_page_filename($page["filename"], $target, $page["id"]);
 }
 }

 $sql = "UPDATE page SET folder_id = ".sqlf_tl_num($target).", edate = ".sqlf_tl_num($TIME).", editor = ".sqlf_tl_num($uid)
 . ", filename = '" . sqlslashes($page["filename"]) . "'";

 
 if ($page["is_master"]) {
 $sql .= ", channel_id = ";
 if ($target_nodeinfo && $target_nodeinfo["master_id"]) {
 $sql .= sqlf_tl_num($target_nodeinfo["id"]);
 } else {
 $sql .= "0";
 }
 }

 $sql .= " WHERE id = " . sqlf_tl_num($page["id"]);
 query($sql);

 
 $o_page = new CNPageObject($page["id"]);
 $o_page->createVersion($TIME, $USER_ID);
 logcmd($W_MOVE, $T_PAGE, $page["id"] , $target, "cmd_file_move");
 triggerEvent( $T_PAGE, $page["id"], EVENT_MOVE, new EventObject( array("toId"=>$target), array($pageinfo["node_id"])));
 }


 
 triggerEvent(T_FOLDER, $target, EVENT_UPDATE, new EventObject(null, "pages"));

 
 $source_folders = array_unique(array_column($move, "folder_id"));
 foreach ($source_folders as $folder_id) {
 triggerEvent(T_FOLDER, $folder_id, EVENT_UPDATE, new EventObject(null, "pages"));
 }

 ignore_user_abort($ignore_user_abort);
 return false;
}





function is_unique_db_column_ci($rows, $field) {
 global $FEATURE;

 $unique_column = array_unique(array_map(cb_cutright('mb_strtolower', 'UTF-8'),
 array_column($rows, $field)));
 if (count($rows) == count($unique_column)) {
 
 return true;
 } else if ($FEATURE["multichannelling"]) {
 
 
 $map = array();
 foreach ($rows as $row) {
 $map[$row[$field]."|".$row["channelset_id"]] = $row[$field];
 }

 $values = array_values($map);
 return count($values) == count(array_unique($values));
 } else {
 return false;
 }
}


function cmd_page_setcdate($page_id,$cdate) {
 global $FEATURE, $T_PAGE;
 
 if (!$page_id) halt(7,"cmd_page_setcdate: no page_id page_id($page_id)");
 if ($cdate == "") halt(7,"cmd_page_setcdate: no cdate cdate($cdate)");
 
 $page = get_pageinfo($page_id);
 
 if ($page['cdate'] != $cdate) {
 query("UPDATE page SET cdate=".sqlf_tl_num($cdate)." WHERE id=".sqlf_tl_num($page_id));
 page_status($page_id, PAGE_STATUS_MODIFIED);
 
 if ($FEATURE["javaparser"]) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_PAGE, $page_id);
 }
 }
}

function cmd_page_createcs() {
 $sql = "INSERT INTO contentset (nada) VALUES (0)";
 $rs = query($sql);
 return $rs["iid"];
}


function cmd_page_checkandfixcs($page_id) {
 $sql = "select contentset_id from page where id = ".sqlf_tl_num($page_id);
 $rs = query($sql);
 if ($rs["arr"][0]["contentset_id"] == 0) {
 $cs = cmd_page_createcs();
 $sql = "update page set contentset_id = ".sqlf_tl_num($cs)." where id = ".sqlf_tl_num($page_id);
 query($sql);
 }
}

function cmd_page_setcg($current_page_id,$page_id,$cg) {
 global $JS;

 $page = get_pageinfo($current_page_id);
 $cs = $page["contentset_id"];

 if ($cg && $page_id) {
 $page2 = get_pageinfo($page_id);
 $cs1 = $page["contentset_id"];
 $cs2 = $page2["contentset_id"];
 $cg1 = $page["contentgroup_id"];
 $cg2 = $page2["contentgroup_id"];








 $sql = "UPDATE page SET contentgroup_id = ".sqlf_tl_num($cg)." WHERE id = ".sqlf_tl_num($page_id);
 query($sql);
 $cg2 = $cg;

 
 if (!$cs1 && $cs2) {
 $sql = "UPDATE page SET contentset_id = 0 WHERE contentgroup_id = ".sqlf_tl_num($cg1)." AND contentset_id = ".sqlf_tl_num($cs2);
 query($sql);
 $sql = "UPDATE page SET contentset_id = ".sqlf_tl_num($cs2)." WHERE id = ".sqlf_tl_num($current_page_id);
 query($sql);
 
 } else if ($cs1) {
 $sql = "UPDATE page SET contentset_id = 0 WHERE contentgroup_id = ".sqlf_tl_num($cg2)." AND contentset_id = ".sqlf_tl_num($cs1);
 query($sql);
 $sql = "UPDATE page SET contentset_id = ".sqlf_tl_num($cs1).", contentgroup_id = ".sqlf_tl_num($cg)." WHERE id = ".sqlf_tl_num($page_id);
 query($sql);
 
 } else {
 $cs = cmd_page_createcs();
 $sql = "UPDATE page SET contentset_id = ".sqlf_tl_num($cs)." WHERE id IN (".sqlf_tl_num($current_page_id).",".sqlf_tl_num($page_id).")";
 query($sql);
 }
 }

 return true;

}

function cmd_page_restore_all( $folder_id, $vdate, $recursive = false )
{
 global $ICO_PAGE;
 $sql = "SELECT id, name FROM page WHERE folder_id = ".sqlf_tl_num($folder_id);
 $rs = query( $sql );
 foreach ( $rs["arr"] as $page )
 {
 $o_page = new CNPageObject($page["id"]);
 if ( !$o_page->restore($vdate) )
 {
 $alert = new AlertStreamInfo();
 $alert->addMessage( 0, $ICO_PAGE, i18n( "Could not restore page {0}", 0, $page["name"] ),
 i18n( "Maybe the page is locked by another user" ) );
 }

 }
}


function cmd_page_save($id) {

 unlock($id,"page");

}

function cmd_page_pub($id, $notify=false) {
 if (!$id) halt(7,"cmd_page_pub: No page_id! page_id($id)");

 cmd_page_timepub($id, 0);
}

function cmd_page_setdirtbehaviour($id, $dirtbehaviour) {
 query("UPDATE page SET dirtbehaviour = ".sqlf_value($dirtbehaviour)." WHERE id = ".sqlf_tl_num($id));
}








function cmd_page_timepub($page_id, $time_pub = 0, $keep_publish_at = false) {
 global $CN_LOCAL_SERVER, $SESSION_TOKEN, $PORTLETAPP_PREFIX_INTERNAL, $FEATURE, $JS;
 if (!$page_id) halt(7,"cmd_page_timepub: No page_id! page_id($page_id)");

 
 if (is_array($page_id) && count($page_id) === 1) {
 
 $page_id = $page_id[0];
 }

 
 if (is_array($page_id)) {
 foreach ( $page_id as $id ) {
 $old_status[$id] = get_page_stat($id);
 }
 } else {
 $old_status[$page_id] = get_page_stat($page_id);
 }

 $request = array();
 $request["message"] = "";
 $request["at"] = $time_pub;
 $request["alllang"] = false;
 $fc = new fetchCurl();
 if (is_array($page_id)) {
 
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/page/publish?sid=$SESSION_TOKEN";
 $request["ids"] = $page_id;
 $request["keepPublishAt"] = ($keep_publish_at) ? 'true' : 'false';
 } else {
 
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/page/publish/$page_id?sid=$SESSION_TOKEN";
 }
 $fc->setUrl($url);
 $fc->setSubmitType("POST");
 $fc->setPostData(json_encode($request));
 $fc->setHeader("Content-Type", "application/json");
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp for setting publish time.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 } else {
 
 if ($FEATURE["workflow"]) {
 if (is_array($page_id)) {
 foreach ( $page_id as $id ) {
 $rs = query("SELECT status FROM page WHERE id = ".sql_num($id));
 $new_status[$id] = $rs["arr"][0]["status"];
 }
 } else {
 $rs = query("SELECT status FROM page WHERE id = ".sql_num($page_id));
 $new_status[$page_id] = $rs["arr"][0]["status"];
 }

 foreach ( $old_status as $id => $old ) {
 $new = $new_status[$id];
 if (($old != $new)) {
 $params = array(
 "page_id" => $id,
 "status" => $new,
 "old_status" => $old,
 "active" => 1,
 "brokenlink_notified" => false);
 trigger_event("onpagestatus", $params);
 }
 }
 }
 }

 $response = json_decode($json, true);
 while (list($key, $m) = each($response["messages"])) {
 
 $alertMessage = str_replace("\r\n", "\n", $m["message"]);

 
 if ($m["type"] === "CRITICAL") {
 
 $JS .= " alert(". json_encode($alertMessage) .");\n";
 }
 }
}



function cutFilenameForExtension($filename, $extLen)
{
 
 
 $max_file_length = 63 - $extLen;

 if (strlen($filename) > $max_file_length) {
 $filename = substr($filename, 0, $max_file_length);
 }

 return $filename;
}

?>
