<?php

GUIFactory :: setMainGUI("main");


if ($USER_ID != 1 && !perm($USER_ID, T_CONTENT, null, 0)) {
 halt(7, "no perms to view nodes");
}

if ($cmd == "new") {
 unset ($FOLDER_ID);
}

if ($cmd != "new" && $USER_ID != 1 && $FOLDER_ID && !perm($USER_ID, T_DOMAIN, $FOLDER_ID, 0) && !perm($USER_ID, T_DOMAIN_CHANNEL, $FOLDER_ID, 0)) {
 halt(7, "no perms to view properties of root folder $FOLDER_ID");
}

if ($cmd == "new") {
 
 if ($USER_ID == 1 || perm($USER_ID, T_CONTENT, null, 8)) {
 $update_perms = true;
 }
}
else {
 
 if ($USER_ID == 1 || perm($USER_ID, T_DOMAIN, $FOLDER_ID, 9) || perm($USER_ID, T_DOMAIN_CHANNEL, $FOLDER_ID, 9) || !$FOLDER_ID) {
 $update_perms = true;
 }
}

if ($FOLDER_ID && $cmd != "new") {
 load_menu(11001, $T_FOLDER, $FOLDER_ID, "", 1, 14002);
}


if ($FOLDER_ID) {
 $cmd = "update";
 $sql = "SELECT f.name, f.description, n.https, n.host, n.pub_dir, n.pub_dir_bin, n.ftpsync, n.ftphost, n.ftplogin, n.ftppassword, n.ftpwwwroot, n.utf8,
	                n.publish_fs, n.publish_contentmap, n.contentmap_handle, n.disable_publish, c.name crname, c.id crid,
	                n.editorversion, n.default_file_folder_id, n.default_image_folder_id, bpm.id as master_id, bpm.name as master_name
	        FROM node n
	        INNER JOIN folder f ON f.node_id = n.id AND n.folder_id = f.id
	        LEFT JOIN folder bpm ON f.master_id = bpm.id
	        LEFT JOIN contentrepository c ON n.contentrepository_id = c.id 
	        WHERE f.id = " . sqlf_tl_num($FOLDER_ID) . " AND n.folder_id = " . sqlf_tl_num($FOLDER_ID);
 $rs = query($sql); 
 $name = $rs["arr"][0]["name"];
 $https = $rs["arr"][0]["https"];
 $host = $rs["arr"][0]["host"];
 $pub_dir = $rs["arr"][0]["pub_dir"];
 $pub_dir_bin = $rs["arr"][0]["pub_dir_bin"];
 $description = $rs["arr"][0]["description"];
 $ftpsync = $rs["arr"][0]["ftpsync"];
 $ftphost = $rs["arr"][0]["ftphost"];
 $ftplogin = $rs["arr"][0]["ftplogin"];
 $ftppassword = $rs["arr"][0]["ftppassword"];
 $ftpwwwroot = $rs["arr"][0]["ftpwwwroot"];
 $utf8 = $rs["arr"][0]["utf8"];
 $publish_fs = $rs["arr"][0]["publish_fs"];
 $publish_contentmap = $rs["arr"][0]["publish_contentmap"];
 $contentmap_handle = $rs["arr"][0]["contentmap_handle"];
 $disable_publish = $rs["arr"][0]["disable_publish"];
 $crname = $rs["arr"][0]["crname"];
 $editorversion = $rs["arr"][0]["editorversion"];
 $crid = $rs["arr"][0]["crid"];
 $master_id = $rs["arr"][0]["master_id"];
 $master_name = $rs["arr"][0]["master_name"];
 $default_file_folder_id = $rs["arr"][0]["default_file_folder_id"];
 $default_image_folder_id = $rs["arr"][0]["default_image_folder_id"];

 




 $checksum = md5($name . $https . $host . $pub_dir . $pub_dir_bin . $description . $ftpsync . $ftphost
 . $ftplogin . $ftppassword . $ftpwwwroot . $utf8 . $publish_fs . $publish_contentmap . $contentmap_handle
 . $disable_publish . $editorversion . $default_file_folder_id . $default_image_folder_id);

 $NODE_ID = $rs["arr"][0]["id"];
}
else {
 
 $cmd = "new";
 $name = i18n('new_node');
 $pub_dir = "/Content.Node";
 $pub_dir_bin = "/Content.Node";
 $utf8 = 1;
 $editorversion = ALOHA;
}


$nodeForm = new HtmlForm3("node");
if ($nodeForm->isNew()) {
 if (!$redo) {
 $redo = 11012;
 }
 $nodeForm->setHeader($name);
 $main = new ListComponent();
 $nodeForm->addComponent('main', $main);
 $main->setComponent('redo', new HiddenComponent($redo));
 $main->setComponent('cmd', new HiddenComponent($cmd));
 $main->setComponent('checksum', new HiddenComponent($checksum));
 $main->setComponent('node_id', new HiddenComponent($cmd === 'new' ? '' : $NODE_ID));
 $main->setComponent('name', $comp = new TextComponent(i18n('368.name'), true, $name, REG_FOLDERNAME));
 $main->setComponent('https', $comp = new CheckBoxComponent(i18n("node.https"), $https));
 $main->setComponent('host', $comp = new TextComponent(i18n('cn_hostname'), true, $host, REG_HOSTNAME));
 $main->setComponent('pub_dir', $comp = new TextComponent(i18n('directory_pages'), true, $pub_dir, REG_PATH));
 $comp->setOptional(true);
 $comp->setHelp(i18n("directory_pages.help"));
 $main->setComponent('separate_pub_dirs', $comp = new CheckBoxComponent(i18n("separate_pub_dirs"), $pub_dir != $pub_dir_bin));
 $comp->setOnChangeAction(new FormAction());
 $comp->setHelp(i18n("separate_pub_dirs.help"));
 $main->setComponent('pub_dir_bin', $comp = new TextComponent(i18n('directory_files'), true, $pub_dir_bin, REG_PATH));
 $comp->setOptional(true);
 $comp->setHelp(i18n("directory_files.help"));

 if ($FEATURE['multichannelling']) {

 if ($cmd === 'new') {
 
 $folders = array ();
 $rs = query("SELECT id, name FROM folder WHERE mother = 0 ORDER BY LOWER(name) ASC");

 while (list ($k, $f) = each($rs["arr"])) {
 if (perm($USER_ID, T_FOLDER, $f["id"], 0)) {
 $folders[$f["id"]] = $f["name"];
 }
 }
 $main->setComponent('master_id', $comp = new SelectComponent(i18n('derives_from'), $folders, $master_id, true));
 $comp->setHelp(i18n('help_select_channel_master'));
 }
 else {
 $main->setComponent('master_id', new HiddenComponent($master_id));
 
 $main->setComponent('master_name', $comp = new TextComponent(i18n('derives_from'), false, $master_name));
 $comp->setHelp(i18n("help_select_channel_master"));
 $comp->setOptional(true);
 $comp->setEditable(false);
 }
 }

 if ($FEATURE["UTF8"]) {
 $main->setComponent('utf8', $comp = new CheckBoxComponent(i18n("UTF8"), $utf8));
 }

 $main->setComponent('editorversion', $comp = new CheckBoxComponent(i18n("Aloha"), $editorversion));
 $comp->setHelp(i18n("Use the next generation Live Editor. Requires UTF-8."));
 $main->setComponent('disable_publish', $comp = new CheckBoxComponent(i18n("Publizierung deaktivieren"), $disable_publish));
 $comp->setHelp(i18n("disable_publish_help"));
 $main->setComponent('publish_fs', $comp = new CheckBoxComponent("<nobr>" . i18n("publish into the filesystem") . "</nobr>", $publish_fs));
 $comp->setHelp(i18n("publish_fs_help"));

 if ($FEATURE["contentmap"]) {
 $main->setComponent('publish_contentmap', $comp = new CheckBoxComponent("<nobr>" . i18n("publish into the contentmap") . "</nobr>", $publish_contentmap));
 $comp->setHelp(i18n("publish_contentmap_help"));
 $main->setComponent('crname', $comp = new TextComponent(i18n("ContentRepository"), false, $crname));
 $comp->setHelp(i18n("node_crname_help"));
 $comp->setOptional(true);
 $comp->setEditable(false);
 }

 if ($FEATURE["node_ftp"]) {
 $main->setComponent('ftpsync', $comp = new CheckBoxComponent(i18n("cn_ftp_sync"), $ftpsync));
 $main->setComponent('ftphost', $comp = new TextComponent(i18n("cn_ftp_hostname"), true, $ftphost));
 $comp->setOptional(true);
 $main->setComponent('ftplogin', $comp = new TextComponent(i18n("cn_ftp_login"), true, $ftplogin));
 $comp->setOptional(true);
 $main->setComponent('ftppassword', $comp = new PasswordComponent(i18n("cn_ftp_password"), true, $ftppassword, 0));
 $comp->setOptional(true);
 $main->setComponent('ftpwwwroot', $comp = new TextComponent(i18n("cn_ftp_webroot"), true, $ftpwwwroot));
 $comp->setOptional(true);
 }

 
 $fileWrapper = new MinibrowserSimpleTree(1, T_CONTENT);
 $fileWrapper->setTType(T_FOLDER, new CNFolderObject());
 $fileWrapper->setTType(T_FOLDER_CHANNEL, new CNInheritedFolderObject());
 $fileWrapper->setTType(T_NODE, new CNFolderNodeObject());
 $fileWrapper->setTType(T_DOMAIN_CHANNEL, new CNChannelObject());
 $fileMB = & $fileWrapper->getMinibrowser();
 $fileMB->addDisplayType(T_NODE);
 $fileMB->addDisplayType(T_DOMAIN_CHANNEL);
 $fileMB->addDisplayType(T_FOLDER);
 $fileMB->addDisplayType(T_FOLDER_CHANNEL);
 $fileMinibrowser = new MinibrowserHiSelector($fileWrapper, i18n('default_file_folder_id'), true);
 $fileMinibrowserfc = & $fileMinibrowser->getFormComponent();
 $fileMinibrowserfc->setHelp(i18n('default_file_folder_id_help'));
 $fileMinibrowserfc->setOptional(true);
 $fileMinibrowser->setOptional(true);
 $main->setComponent('default_file_folder_id', $fileMinibrowser);

 
 if ($default_file_folder_id > 0) {
 $defaultFileFolder = new CNFolderObject($default_file_folder_id);
 $fileMinibrowser->setObject($defaultFileFolder);
 $fileMinibrowser->setFieldValue("u_type", 10002);
 $fileMinibrowser->setFieldValue("u_id", $defaultFileFolder->getId());
 }

 
 $imageWrapper = new MinibrowserSimpleTree(1, T_CONTENT);
 $imageWrapper->setTType(T_FOLDER, new CNFolderObject());
 $imageWrapper->setTType(T_FOLDER_CHANNEL, new CNInheritedFolderObject());
 $imageWrapper->setTType(T_NODE, new CNFolderNodeObject());
 $imageWrapper->setTType(T_DOMAIN_CHANNEL, new CNChannelObject());
 $imageMB = & $imageWrapper->getMinibrowser();
 $imageMB->addDisplayType(T_NODE);
 $imageMB->addDisplayType(T_DOMAIN_CHANNEL);
 $imageMB->addDisplayType(T_FOLDER);
 $imageMB->addDisplayType(T_FOLDER_CHANNEL);
 $imageMinibrowser = new MinibrowserHiSelector($imageWrapper, i18n('default_image_folder_id'), true);
 $imageMinibrowserfc = & $imageMinibrowser->getFormComponent();
 $imageMinibrowserfc->setHelp(i18n('default_image_folder_id_help'));
 $imageMinibrowserfc->setOptional(true);
 $imageMinibrowser->setOptional(true);
 $main->setComponent('default_image_folder_id', $imageMinibrowser);

 
 if ($default_image_folder_id > 0) {
 $defaultImageFolder = new CNFolderObject($default_image_folder_id);
 $imageMinibrowser->setObject($defaultImageFolder);
 $imageMinibrowser->setFieldValue("u_type", 10002);
 $imageMinibrowser->setFieldValue("u_id", $defaultImageFolder->getId());
 }

 $main->setComponent('description', $comp = new TextAreaComponent(i18n('305.description'), true, $description, REG_TEXT));
 $comp->setOptional(true);
 $comp->setHelp(i18n('305.description'));

 
 if ($update_perms) {
 $nodeForm->addButton('ok', new Button(i18n("OK")), new SimpleFormAction("saveNode"), true);
 }

 $nodeForm->addButton('cancel', new Button(i18n("cancel"), false), new RedoFormAction($redo), false);
}



$pub_dir_bin_comp = & $nodeForm->resolveComponent("main.pub_dir_bin");
$pub_dir_bin = & $nodeForm->resolveComponent("main.pub_dir");
$separate_pub_dirs_comp = & $nodeForm->resolveComponent("main.separate_pub_dirs");

if ($separate_pub_dirs_comp->isChecked()) {
 $pub_dir_bin_comp->setDisabled(false);
}
else {
 $pub_dir_bin_comp->setDisabled(true);
 $pub_dir_bin_comp->setText($pub_dir_bin->getText());
 
 $JS .= '$(function () {
	  $("input[name=\'node_mainpub_dirt\']").keyup( function() {
	    $("input[name=\'node_mainpub_dir_bint\']").val($("input[name=\'node_mainpub_dirt\']").val());
	  });
	  $("input[name=\'node_mainpub_dirt\']").change( function() {
	    $("input[name=\'node_mainpub_dir_bint\']").val($("input[name=\'node_mainpub_dirt\']").val());
	  });
	});';
}





function saveNode(& $form) {
 global $FEATURE, $USER_ID, $FOLDER_ID, $REDO, $JS, $STAG, $ERROR, $ERROR_ATTR;
 $redo = $form->resolveComponent("main.redo")->getValue();
 $cmd = $form->resolveComponent("main.cmd")->getValue();
 $checksum = $form->resolveComponent("main.checksum")->getValue();
 $node_id = $form->resolveComponent("main.node_id")->getValue();
 $name = $form->resolveComponent("main.name")->getText();
 $https = $form->resolveComponent("main.https")->isChecked() ? 1 : 0;
 $host = $form->resolveComponent("main.host")->getText();
 $pub_dir = $form->resolveComponent("main.pub_dir")->getText();

 if ($form->resolveComponent("main.separate_pub_dirs")->isChecked()) {
 $pub_dir_bin = $form->resolveComponent("main.pub_dir_bin")->getText();
 }
 else {
 $pub_dir_bin = $pub_dir;
 }

 $description = $form->resolveComponent("main.description")->getText();

 if ($FEATURE["node_ftp"]) {
 $ftpsync = $form->resolveComponent("main.ftpsync")->isChecked() ? 1 : 0;
 $ftphost = $form->resolveComponent("main.ftphost")->getText();
 $ftplogin = $form->resolveComponent("main.ftplogin")->getText();
 $ftppassword = $form->resolveComponent("main.ftppassword")->getText();
 $ftpwwwroot = $form->resolveComponent("main.ftpwwwroot")->getText();
 }
 else {
 $ftpsync = 0;
 $ftpwwwroot = ".";
 }

 if ($FEATURE["UTF8"]) {
 $utf8 = $form->resolveComponent("main.utf8")->isChecked() ? 1 : 0;
 }
 else {
 $utf8 = 0;
 }

 $publish_fs = $form->resolveComponent("main.publish_fs")->isChecked() ? 1 : 0;

 if ($FEATURE["contentmap"]) {
 $publish_contentmap = $form->resolveComponent("main.publish_contentmap")->isChecked() ? 1 : 0;
 $contentmap_handle = "";
 }
 else {
 $publish_contentmap = 0;
 }

 $disable_publish = $form->resolveComponent("main.disable_publish")->isChecked() ? 1 : 0;
 $editorversion = $form->resolveComponent("main.editorversion")->isChecked() ? 1 : 0;

 if ($FEATURE["multichannelling"] && $cmd === 'new') {
 $master_id = $form->resolveComponent("main.master_id")->getSingleSelection();
 }
 else {
 $master_id = 0;
 }

 $defaultFile = $form->resolveComponent('main.default_file_folder_id')->getResultObject();
 $default_file_folder_id = $defaultFile->getId();
 $defaultImage = $form->resolveComponent('main.default_image_folder_id')->getResultObject();
 $default_image_folder_id = $defaultImage->getId();
 $checksum_new = md5($name . $https . $host . $pub_dir . $pub_dir_bin . $description . $ftpsync . $ftphost . $ftplogin . $ftppassword . $ftpwwwroot . $utf8 . $publish_fs . $publish_contentmap . $contentmap_handle . $disable_publish . $editorversion . $default_file_folder_id . $default_image_folder_id);

 if ($editorversion == ALOHA && !$utf8) {
 $form->resolveComponent("main.editorversion")->addError(new NodeException(i18n("Aloha requires UTF-8")));
 }
 else {
 
 switch ($cmd) {
 case "new" :
 if ($USER_ID != 1 && !perm($USER_ID, T_CONTENT, null, 8)) {
 halt(7, "no perms to create a new node");
 }

 $node_id = cmd_node_create($name, $https, $host, $pub_dir, $pub_dir_bin, $description, $ftpsync, $ftphost, $ftplogin, $ftppassword, $ftpwwwroot, $utf8, $publish_fs, $publish_contentmap, $contentmap_handle, $disable_publish, $editorversion, $master_id, $default_file_folder_id, $default_image_folder_id);
 $NODE_ID = $node_id;
 
 $sql = "SELECT count(*) AS c FROM construct WHERE id = 1";
 $rs = query($sql); 
 
 if ($rs["arr"][0]["c"] == 1) {
 cmd_construct_node(1, array (
 $node_id => 1
 ));
 }

 break;
 case "update" :
 if ($USER_ID != 1 && !(perm($USER_ID, T_DOMAIN, $FOLDER_ID, 9) || perm($USER_ID, T_DOMAIN_CHANNEL, $FOLDER_ID, 9) )) {
 halt(7, "no perms to update the node");
 }

 if (strcmp($checksum, $checksum_new) != 0) {
 
 if ($USER_ID == 1 || perm($USER_ID, T_DOMAIN, $FOLDER_ID, 9) ||
 perm($USER_ID, T_DOMAIN_CHANNEL, $FOLDER_ID, 9) || !$FOLDER_ID)
 {
 $node_id = cmd_node_update(
 $FOLDER_ID, $name, $https, $host, $pub_dir, $pub_dir_bin, $description, $ftpsync,
 $ftphost, $ftplogin, $ftppassword, $ftpwwwroot, $utf8, $publish_fs,
 $publish_contentmap, $contentmap_handle, $disable_publish, $editorversion,
 $default_file_folder_id, $default_image_folder_id
 );
 }
 }

 break;
 } 

 if ($ERROR) {
 if ($ERROR_ATTR) {
 $form->resolveComponent("main.$ERROR_ATTR")->addError(new NodeException($ERROR));
 }
 else {
 $form->addError(new NodeException($ERROR));
 }
 }
 else {
 $REDO = $redo;
 $JS = "
			if (top.tree) {
			  top.tree.location='$STAG&do=300';
			}
			";
 }
 }
}

if (!$REDO) {
 if ($publish_contentmap && !$publish_fs) {
 $linkway = "portal";
 }
 else {
 $linkway = $LINKWAY;
 }
 if ($linkway == "portal" || $linkway == "auto" || $linkway == "host") {
 $ASSCORE = i18n("node_linkway_$linkway") . "<br/>" . i18n("node_linkway_description");
 }
}










function validate_node_props($name, $description, $host, $pub_dir, $html_form) {
 node_include('validation');

 return validate_properties_htmlform(array (
 'nodeName' => $name,
 'nodeDescription' => $description,
 'hostName' => $host,
 'fsPath' => $pub_dir
 ), new InputValidationRequest(), $html_form, array (
 'nodeName' => 'name',
 'nodeDescription' => 'description',
 'hostName' => 'host',
 'fsPath' => 'pub_dir'
 ));
}
