<?








function verifyEditInherited($obj_type, $obj_id, $channel_id, $inherited_channel_id) {
 global $VERIFIED_EDIT_INHERITED;

 
 mysession_var_reg('VERIFIED_EDIT_INHERITED');
 $VERIFIED_EDIT_INHERITED = array('obj_type' => $obj_type, 'obj_id' => $obj_id, 'channel_id' => $channel_id, 'inherited_channel_id' => $inherited_channel_id);
}








function isEditInheritedVerified($obj_type, $obj_id, $channel_id) {
 global $VERIFIED_EDIT_INHERITED;

 if (!is_array($VERIFIED_EDIT_INHERITED)) {
 return false;
 }

 return $VERIFIED_EDIT_INHERITED['obj_type'] == $obj_type
 && $VERIFIED_EDIT_INHERITED['obj_id'] == $obj_id
 && $VERIFIED_EDIT_INHERITED['channel_id'] == $channel_id;
}





function getEditInheritedChannel() {
 global $VERIFIED_EDIT_INHERITED;
 return $VERIFIED_EDIT_INHERITED['inherited_channel_id'];
}





function localizeAndEdit(&$form) {
 global $NODE_ID, $REDO;

 
 $obj_type_comp = &$form->resolveComponent("main.obj_type");
 $obj_type = $obj_type_comp->getValue();
 $obj_id_comp = &$form->resolveComponent("main.obj_id");
 $obj_id = $obj_id_comp->getValue();
 $do_cancel_comp = &$form->resolveComponent("main.do_cancel");
 $do_cancel = $do_cancel_comp->getValue();
 $do_edit_comp = &$form->resolveComponent("main.do_edit");
 $do_edit = $do_edit_comp->getValue();
 $obj_id_param_comp = &$form->resolveComponent("main.obj_id_param");
 $obj_id_param = $obj_id_param_comp->getValue();
 $do_params_comp = &$form->resolveComponent("main.do_params");
 $do_params = $do_params_comp->getValue();

 
 $javaParser =& CodeParser::getJavaParser();
 $rs = $javaParser->localizeObject($obj_type, $obj_id, $NODE_ID, true);

 
 $loc_id = getLocalizedObject($obj_type, $obj_id, $NODE_ID);

 
 if (!$loc_id) {
 $REDO = $do_cancel;
 } else {
 global $$obj_id_param;
 $$obj_id_param = $loc_id;
 $REDO = $do_edit;

 if (is_array($do_params)) {
 reset($do_params);
 while (list($key, $val) = each($do_params)) {
 global $$key;
 $$key = $val;
 }
 }
 }
}










function getLocalizedObject($obj_type, $master_id, $channel_id) {
 switch($obj_type) {
 case T_PAGE:
 $sql = "SELECT p2.id FROM page p1 LEFT JOIN page p2 ON p1.channelset_id = p2.channelset_id WHERE p1.id = ".sqlf_tl_num($master_id)." AND p2.channel_id = ".sqlf_tl_num($channel_id);
 break;
 case T_TEMPLATE:
 $sql = "SELECT t2.id FROM template t1 LEFT JOIN template t2 ON t1.channelset_id = t2.channelset_id WHERE t1.id = ".sqlf_tl_num($master_id)." AND t2.channel_id = ".sqlf_tl_num($channel_id);
 break;
 case CT_FILE:
 case T_IMAGE:
 $sql = "SELECT cf2.id FROM contentfile cf1 LEFT JOIN contentfile cf2 ON cf1.channelset_id = cf2.channelset_id WHERE cf1.id = ".sqlf_tl_num($master_id)." AND cf2.channel_id = ".sqlf_tl_num($channel_id);
 break;
 default:
 return false;
 }

 $rs = query($sql);
 if ($rs["num"] == 0) {
 return false;
 } else {
 return $rs["arr"][0]["id"];
 }
}





function editInherited(&$form) {
 global $REDO, $VERIFIED_EDIT_INHERITED, $NODE_ID;

 $do_edit_comp = &$form->resolveComponent("main.do_edit");
 $do_edit = $do_edit_comp->getValue();

 $obj_type_comp = &$form->resolveComponent("main.obj_type");
 $obj_type = $obj_type_comp->getValue();

 $obj_id_comp = &$form->resolveComponent("main.obj_id");
 $obj_id = $obj_id_comp->getValue();

 $obj_id_param_comp = &$form->resolveComponent("main.obj_id_param");
 $obj_id_param = $obj_id_param_comp->getValue();

 $do_params_comp = &$form->resolveComponent("main.do_params");
 $do_params = $do_params_comp->getValue();

 $inherited_node = &$form->resolveComponent("main.inherited_node")->getValue();

 global $$obj_id_param, $NODE_ID;
 $$obj_id_param = $obj_id;

 $REDO = $do_edit;

 verifyEditInherited($obj_type, $obj_id, $NODE_ID, $inherited_node);

 
 
 
 $NODE_ID=$inherited_node;

 if (is_array($do_params)) {
 reset($do_params);
 while (list($key, $val) = each($do_params)) {
 global $$key;
 $$key = $val;
 }
 }
}
?>